/*
	WinMain֌W
*/

#include <windows.h>
#include <stdio.h>

#include "resource.h"
#include "window.h"
#include "mges.h"

/*==============================================================
//	EBhE֌W̏
//============================================================*/
BOOL Initialize(										/*OUT	:	*/
	HINSTANCE hInstance,								/*IN	:݂̃CX^X̃nh	*/
	int iCmdShow										/*IN	:\	*/
) 
{
	const char*	szClassName		= "sample";
	const char*	szWindowName	= "mges sample";
	HWND			hWnd;
	WNDCLASSEX		obWCEX;

	/*	EBhENXo^	*/
	obWCEX.cbSize			= sizeof(WNDCLASSEX);
	obWCEX.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	obWCEX.lpfnWndProc		= SampleProc;
	obWCEX.cbClsExtra		= 0;
	obWCEX.cbWndExtra		= 0;
	obWCEX.hInstance		= hInstance;
	obWCEX.hIcon			= NULL;
	obWCEX.hCursor			= LoadCursor(NULL, IDC_ARROW);
	obWCEX.hbrBackground	= (HBRUSH)(COLOR_WINDOW + 1);
	obWCEX.lpszMenuName		= NULL;
	obWCEX.lpszClassName	= szClassName;
	obWCEX.hIconSm			= NULL;
	if (!RegisterClassEx(&obWCEX)) {
		return FALSE;
	}
	/*	EBhE쐬	*/
	hWnd	= CreateWindowEx(
				WS_EX_CLIENTEDGE,
				szClassName,
				szWindowName,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				CW_USEDEFAULT,
				CW_USEDEFAULT,
				320,
				240,
				NULL,
				LoadMenu(hInstance, MAKEINTRESOURCE(IDR_SAMPLE)),
				hInstance,
				NULL);
	if (hWnd == NULL) {
		return FALSE;
	}
	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}

/*==============================================================
//	Gg|Cg
//============================================================*/
int APIENTRY WinMain(									/*OUT	:IR[h	*/
	HINSTANCE hInstance,								/*IN	:݂̃CX^X̃nh	*/
	HINSTANCE hPrevInstance,							/*IN	:ȑÕCX^X̃nh	*/
	LPSTR lpCmdLine,									/*IN	:R}hC	*/
	int iCmdShow										/*IN	:\	*/
)
{
	MSG		obMSG;
	
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	if (!Initialize(hInstance, iCmdShow)) {
		return 0;
	}
	while (GetMessage(&obMSG, NULL, 0, 0)) {
		if (!MgesTranslate(&obMSG)) {
			TranslateMessage(&obMSG);
			DispatchMessage(&obMSG);
		}
	}
	return obMSG.wParam;
}
