/*
	EBhEbZ[W̏֌W
*/

#include <windows.h>
#include <stdio.h>

#include "resource.h"
#include "window.h"
#include "mges.h"

/*==============================================================
//	Window Proc
//============================================================*/
LRESULT CALLBACK SampleProc(							/*OUT	:	*/
	HWND hWnd,											/*IN	:EBhEnh	*/
	UINT message,										/*IN	:EBhEbZ[W	*/
	WPARAM wParam,										/*IN	:p[^P	*/
	LPARAM lParam										/*IN	:p[^Q	*/
)
{
	static char	cString[256]	= "";
	char	c[32];

	switch (message) {
		case WM_CREATE:
			/*	Mges ֘Ȁ	*/
			if (!MgesInitialize(hWnd)) {
				MessageBox(hWnd, "Mges ̏G[", "error", MB_OK);
				return -1;
			}
			/*	W̃WFX`[ݒ	*/
			SetDefaultGesture();
			/*	j[̃V[gJbg\LXV	*/
			MgesUpdateMenuString(GetMenu(hWnd));
			break;
		case WM_CLOSE:
			DestroyWindow(hWnd);
			break;
		case WM_DESTROY:
			/*	Mges ֘Ǎ㏈	*/
			MgesRelease();
			PostQuitMessage(0);
			break;
		case WM_PAINT:
			OnPaint(hWnd, cString);
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDM_CONFIG:
					/*	Mges ݒ_CAO	*/
					if (MgesConfigDialog(hWnd)) {
						/*	XVꂽ̂ŁAj[̃V[gJbg\LXV	*/
						MgesUpdateMenuString(GetMenu(hWnd));
					}
					break;
				case IDM_MENU_001:
				case IDM_MENU_002:
				case IDM_MENU_003:
				case IDM_MENU_004:
					/*	j[ɑΉbZ[W\	*/
					sprintf(c, "j[ %d s", LOWORD(wParam) - IDM_MENU_001 + 1);
					MessageBox(hWnd, c, "", MB_OK);
					break;
				default:
					return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case UM_MGES_COMMAND:	/*	}EXWFX`[mʒm [U[`bZ[W	*/
			/*	}EXWFX`[ɑΉ鏈s	*/
			DoGestureCommand(hWnd, wParam);
			break;
		case UM_MGES_STRING:	/*	̓}EXWFX`[̕ʒm [U[`bZ[W	*/
			/*	}EXWFX`[̕ʏɕ\	*/
			strncpy(cString, (LPCSTR)wParam, 255);
			cString[255]	= '\0';
			InvalidateRect(hWnd, NULL, TRUE);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
/*==============================================================
//	WM_PAINT
//============================================================*/
static void OnPaint(
	const HWND hWnd,									/*IN	:EBhEnh	*/
	LPCSTR lpc											/*IN	:\	*/
)
{
	PAINTSTRUCT	obPS;
	RECT		rect;
	HDC			hDC;

	GetClientRect(hWnd, &rect);
	InflateRect(&rect, -((rect.right - rect.left) >> 3), -((rect.bottom - rect.top) >> 2));

	hDC	= BeginPaint(hWnd, &obPS);
	DrawText(hDC, lpc, -1, &rect, DT_CENTER);
	EndPaint(hWnd, &obPS);
}
/*==============================================================
//	}EXWFX`[ʎs
//============================================================*/
static void DoGestureCommand(
	const HWND hWnd,									/*IN	:EBhEnh	*/
	const DWORD dwID									/*IN	:ANVID	*/
)
{
	char	c[32];

	if ((dwID & 0x80000000) == 0) {
		/*	ŏʂ̃tOĂȂꍇ͂̂܂ WM_COMMAND ɗɂ	*/
		PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(dwID, 0), 0L);
	}
	else {
		/*	ŏʂ̃tOĂꍇ͓Kȏ鎖ɂ悤	*/
		switch (dwID & 0x7fffffff) {
			case 1:		/*	EBhEɎOɕ\	*/
				SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
				break;
			case 2:		/*	EBhEɎOɕ\	*/
				SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
				break;
			default:	/*	̑	*/
				sprintf(c, "R}h %08x s", dwID & 0x7fffffff);
				MessageBox(hWnd, c, "", MB_OK);
				break;
		}
	}
}
/*==============================================================
//	W̃WFX`[ݒ
//============================================================*/
static void SetDefaultGesture()
{
	DWORD	dwGesture[16];

	/*	uݒ_CAOvj[ɑΉ}EXWFX`[	*/
	dwGesture[0]		= 0x00000a81;	/*	uL  v	*/
	dwGesture[1]		= IDM_CONFIG;
	/*	uEBhEɎOɕ\vɑΉ}EXWFX`[	*/
	dwGesture[2]		= 0x00000082;	/*	uR v	*/
	dwGesture[3]		= 0x80000001;
	/*	uEBhEɎOɕ\vɑΉ}EXWFX`[	*/
	dwGesture[4]		= 0x000000a2;	/*	uR v	*/
	dwGesture[5]		= 0x80000002;

	/*	W}EXWFX`[ݒ	*/
	MgesSetDefaultGesture(dwGesture, 3, TRUE);

	/*	uj[vj[ɑΉL[{[hWFX`[	*/
	dwGesture[0]		= VK_F1;						/*	uF1v	*/
	dwGesture[1]		= IDM_MENU_001;
	dwGesture[2]		= (FCONTROL << 16) | VK_SPACE;	/*	uCtrl + Spacev	*/
	dwGesture[3]		= IDM_MENU_001;
	/*	uj[vj[ɑΉL[{[hWFX`[	*/
	dwGesture[4]		= VK_F2;						/*	uF2v	*/
	dwGesture[5]		= IDM_MENU_002;
	dwGesture[6]		= (FSHIFT << 16) | VK_SPACE;	/*	uShift + Spacev	*/
	dwGesture[7]		= IDM_MENU_002;
	/*	uj[Qvj[ɑΉL[{[hWFX`[	*/
	dwGesture[8]		= VK_F3;						/*	uF3v	*/
	dwGesture[9]		= IDM_MENU_003;
	dwGesture[10]		= (FALT << 16) | VK_SPACE;		/*	uAlt + Spacev	*/
	dwGesture[11]		= IDM_MENU_003;
	/*	uj[lvj[ɑΉL[{[hWFX`[	*/
	dwGesture[12]		= VK_F4;						/*	uF4v	*/
	dwGesture[13]		= IDM_MENU_004;
	dwGesture[14]		= ((FCONTROL | FSHIFT | FALT) << 16) | VK_SPACE;	/*	uCtrl + Shift + Alt + Spacev	*/
	dwGesture[15]		= IDM_MENU_004;

	/*	WL[{[hWFX`[ݒ	*/
	MgesSetDefaultGesture(dwGesture, 8, FALSE);
}
